const staggerVisualizerEl = document.querySelector(".stagger-visualizer");
const fragment = document.createDocumentFragment();
const numberOfElements = 81;

for (let i = 0; i < numberOfElements; i++) {
  fragment.appendChild(document.createElement("div"));
}

staggerVisualizerEl.appendChild(fragment);

const information = anime
  .timeline({
    targets: ".stagger-visualizer div",
    easing: "easeInOutSine",
    delay: anime.stagger(50),
    loop: true,
    autoplay: false,
    duration: 600,
    loopComplete: (a) => console.log("end"),
    //update: () => console.log(staggersAnimation.progress)
  })
  .add({
    scale: anime.stagger([2.5, 1], { from: "center", grid: [9, 9] }),
    translateX: anime.stagger([-100, 100]),
    rotate: anime.stagger([-45, 45]),
    easing: "easeInOutCirc",
    delay: anime.stagger(10, { from: "center" }),
    border: "0.5px solid #fff",
  })
  .add({
    translateX: () => anime.random(-100, 100),
    translateY: () => anime.random(-100, 100),
    scale: anime.stagger([1.5, 0.5], { from: "center" }),
    rotate: anime.stagger([10, -10], { from: "last" }),
    delay: anime.stagger(50, { from: "center", grid: [9, 9] }),
  })
  .add({
    translateX: anime.stagger([25, -25], { from: "first" }),
    translateY: 0,
    rotate: anime.stagger([40, -40], { from: "first" }),
    delay: anime.stagger(10, { from: "first" }),
  })
  .add({
    translateY: anime.stagger([-240, 240]),
    rotate: () => anime.random(-100, 100),
    scale: anime.stagger([1, 3], { from: "center" }),
    delay: anime.stagger(10, { from: 0 }),
  })
  .add({
    translateX: 0,
    translateY: 0,
    scale: 1,
    rotate: 360,
    duration: 2000,
    delay: 0,
  });

const conscious = anime
  .timeline({
    easing: "easeInOutQuad",
    autoplay: false,
    loop: true,
  })
  .add({
    targets: ".baseline",
    width: ["100%", "30%"],
    easing: "easeInOutQuad",
    duration: 1500,
  })
  .add({
    targets: ".baseline",
    width: ["30%", "5%"],
    easing: "easeInOutQuad",
    duration: 300,
    endDelay: 200,
  })
  .add({
    targets: ".baseline",
    width: ["5%", "100%"],
    easing: "easeInOutQuad",
    duration: 1500,
  })
  .add({
    targets: ".baseline",
    width: ["100%", "5%"],
    easing: "easeInOutQuad",
    duration: 300,
    endDelay: 200,
  })
  .add({
    targets: ".baseline",
    width: ["5%", "10%"],
    easing: "easeInOutQuad",
    duration: 500,
    endDelay: 1100,
  })
  .add({
    targets: ".baseline",
    width: ["10%", "100%"],
    easing: "easeInOutQuad",
    duration: 1200,
    endDelay: 100,
  });

const genesisByRiafy = anime
  .timeline({
    easing: "easeInOutQuad",
    autoplay: false,
  })
  .add({
    targets: ".footer",
    bottom: "32px",
    easing: "easeInOutQuad",
    duration: 1500,
  });

function bootComplete() {
  information.pause();
  conscious.pause();

  information2 = anime
    .timeline({
      targets: ".stagger-visualizer div",
      easing: "easeInOutSine",
      delay: anime.stagger(50),
      autoplay: true,
      duration: 600,
    })
    .add({
      translateX: 0,
      translateY: 1000,
      scale: 1,
      rotate: 0,
      duration: 2000,
      delay: 0,
    });

  conscious2 = anime
    .timeline({
      easing: "easeInOutQuad",
      autoplay: true,
    })
    .add({
      targets: ".baseline",
      bottom: "-25px",
      height: "50px",
      width: "50px",
      easing: "easeInOutQuad",
      duration: 1500,
    });

  outroSequence = anime
    .timeline({
      easing: "easeInOutQuad",
      autoplay: true,
      loopComplete: (a) => {
        document.querySelector(".bootProcess").classList.add("displayNone");
        document
          .querySelector(".generatedContainer")
          .classList.remove("displayNone");
      },
    })
    .add({
      targets: ".header",
      opacity: 0,
      duration: 1500,
    });

  introSequnce = anime
    .timeline({
      easing: "easeInOutQuad",
      autoplay: true,
      delay: 100,
    })
    .add({
      targets: ".botName",
      opacity: 1,
      duration: 150,
    })
    .add({
      targets: ".botDesc",
      opacity: 1,
      duration: 150,
    })
    .add({
      targets: ".footer",
      opacity: 0,
      duration: 50,
    })
    .add({
      targets: ".textSegment",
      opacity: 1,
      bottom: "16px",
      duration: 50,
    });
}
const animationStart = () => {
  genesisByRiafy.play();
  conscious.play();
  information.play();
};
