class Feedback extends HTMLElement {
  constructor() {
    super();

    this._overlayContainer;
    this._feedButton;
    this._feedIcon;
    this._userFeedBack;
    this._feedSubmitBtn;
    this._feedCloseBtn;
    this._feedbackTitle;
    this._feedbackCheckboxes;
    this._feedbackNpsScores;
    this._data = {};

    this.attachShadow({ mode: "open" });
    this.shadowRoot.innerHTML = `
        <style>
            * {
              margin: 0;
              padding: 0;
              box-sizing: border-box;
              font-family: "Poppins", sans-serif;
              -webkit-tap-highlight-color: transparent;
              -webkit-touch-callout: none;
              user-select: none;
              -moz-user-select: none;
              -webkit-user-drag: none;
              -webkit-user-select: none;
              -ms-user-select: none;
            }
            body {
                background: red;
            }
            .feed-overlay-container {
                display: none;
                opacity: 0;
                justify-content: center;
                align-items: center;
                position: fixed;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                z-index: 99999999;
                transition: all 0.3s ease-in-out;
                animation: fade-in 0.3s;

                background: rgb(246 244 242 / 50%);
                transition-duration: 1.2s;
                backdrop-filter: blur(5px);
                -webkit-backdrop-filter: blur(5px);
            }

            .feed-overlay {
                display: flex;
                flex-direction: column;
                background: var(--secondary-bg);
                max-width: 32rem;
                width: 80%;
                padding: 1.5rem 1rem;
                border-radius: 0.375rem;
                font-size:14px;

                box-shadow: 0px 0px 15px 4px rgba(0, 0, 0, 0.11);
                transition: 0.3s transform ease;
                border-radius: 16px;
                width: 90%;
                max-width: 520px;
                transform: translate(0, 180%);
            }
            .feed-visible {
              transform: translate(0, 0);
            }
            @media screen and (max-width: 430px) {
              .feed-overlay {
                width: 90%;
              }
            }

            #feedButton {
                cursor: pointer;
                outline: none;
                border: none;
                background-color: transparent;
                width: 3.438rem;
                height: 3.438rem;
                display: flex;
                align-items: center;
                justify-content: center;
                border-radius: 1.25rem;
                font-size: 1.25rem;
                background: var(--glass-bg);
                color: #fff;
            }
            #feedButton:disabled {
              opacity: 0.5;
            }
            // #feedButton:hover {
            //   background-color: #ddd;
            // }
            // #feedButton:disabled {
            //   background-color: #ddd;
            // }
            // #feedButton:disabled:hover {
            //   background-color: transparent;
            // }
            // #feedButton:disabled svg {
            //   color: #000;
            // }
            // #feedButton.down svg {
            //   transform: rotate(180deg);
            //   margin-top: 3px;
            // }
            #feedButton.down svg {
              filter: var(--image-invert);
              width: 1.845rem;
            }
            textarea {
                margin: 1rem 0;
                border: 1px solid #8e8ea0;
                line-height: 1.5rem;
                padding: 0.5rem 0.75rem;
                outline: red;
                resize: none;
                height: 90px;
                overflow-y: hidden;
                border-radius: 0.375rem;
                background-color: var(--glass-bg);
                color: var(--primary-text);
            }
            textarea::placeholder {
              color: var(--placeholder);
            }
            .checkboxes {
                display: flex;
                flex-direction: column;
            }
            .single-checkbox-contain {
                display: flex;
                align-items: center;
                cursor: pointer;
                padding: 4px 0;
            }
            .single-checkbox-contain input {
                margin: 0;
                margin-right: 10px;
                transform : scale(1.1);
            }
            .nps-container {
              margin: 16px 0;
            }

            .nps-score-container {
              display: flex;
              width: 100%;
            }
            .nps-score {
              display: flex;
              justify-content: center;
              align-items: center;
              width: calc(100%/11);
              height: 38px;
              background: #ececec;
              cursor: pointer;

              background: #ff6961;
              color: #fff;
            }
            .nps-score:first-child {
              border-radius: 10px 0 0 10px;
            }
            .nps-score:last-child {
              border-radius: 0 10px 10px 0;
            }
            .nps-score:nth-child(7),
            .nps-score:nth-child(8),
            .nps-score:nth-child(9) {
              background: #FFC55C;
            }
            .nps-score:nth-child(10),
            .nps-score:nth-child(11) {
              background: #77dd77;
            }
            .nps-score.selected,
            .nps-score:hover {
              opacity: 0.6;
            }
            .nps-title {
              margin-bottom: 10px;
              color: var(--primary-text);
            }
            #submitFeedBtn {
              cursor: pointer;
              outline: none;
              border: none;
              align-self: end;
              padding: 8px 12px;
              height: 40px;
              border-radius: 12px;
              background: #000;
              color: #fff;
            }
            #submitFeedBtn:active {
              background: linear-gradient(133deg, #000, #4c4c4c);
            }
            #submitFeedBtn:disabled {
              opacity: 0.7;
            }
            #feedCloseBtn {
              cursor: pointer;
              outline: none;
              border: none;
              position: absolute;
              top: 0;
              right: 0;
              background: transparent;
              opacity: .5;
            }
            #feedCloseBtn svg {
              stroke: var(--primary-text);
            }
            .feed-header {
              display: flex;
              align-items: center;
              position: relative;
            }
            .feed-icon {
              display: flex;
              align-items: center;
              justify-content: center;
              background-color: #D1F4D3;
              width: 50px;
              height: 50px;
              border-radius: 50%;
              margin-right: 1rem;
              flex-shrink: 0;
            }
            #feedIcon svg {
              transform: scale(1.3) rotate(0deg);
              color: #207556;
            }
            #feedIcon.down {
              background-color: #FEE1E3;
            }
            #feedIcon.down svg {
              color: #BE2A28;
              transform: rotate(180deg);
          }
            @keyframes fade-in {
                from {
                    opacity: 0;
                }
                
                to {
                    opacity: 1;
                }
            }
        </style>
        <div class="feed-overlay-container">
            <div class="feed-overlay">
              <div class="feed-header">
                <div class="feed-icon" id="feedIcon">
                <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-alert-circle"><circle cx="12" cy="12" r="10"></circle><line x1="12" y1="8" x2="12" y2="12"></line><line x1="12" y1="16" x2="12.01" y2="16"></line></svg>
                </div>
                <div id="feedbackTitle"></div>
                <button id="feedCloseBtn">
                  <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-x-circle"><circle cx="12" cy="12" r="10"></circle><line x1="15" y1="9" x2="9" y2="15"></line><line x1="9" y1="9" x2="15" y2="15"></line></svg>
                </button>
              </div>
              <textarea id="userFeedBack"></textarea>
              <div id="checkboxes"></div>
              <div class="nps-container">
                <div class="nps-title">Please rate the image</div>
                <div class="nps-score-container">
                  <div data-selected="false" class="nps-score">0</div>
                  <div data-selected="false" class="nps-score">1</div>
                  <div data-selected="false" class="nps-score">2</div>
                  <div data-selected="false" class="nps-score">3</div>
                  <div data-selected="false" class="nps-score">4</div>
                  <div data-selected="false" class="nps-score">5</div>
                  <div data-selected="false" class="nps-score">6</div>
                  <div data-selected="false" class="nps-score">7</div>
                  <div data-selected="false" class="nps-score">8</div>
                  <div data-selected="false" class="nps-score">9</div>
                  <div data-selected="false" class="nps-score">10</div>
                </div>
              </div>
              <button id="submitFeedBtn" disabled="true">Submit Feedback</button>
            </div>
        </div>

        <button id="feedButton">
          <svg width="24" height="26" viewBox="0 0 24 26" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M12.0001 15.1C11.5081 15.1 11.1001 14.692 11.1001 14.2V7.9C11.1001 7.408 11.5081 7 12.0001 7C12.4921 7 12.9001 7.408 12.9001 7.9V14.2C12.9001 14.692 12.4921 15.1 12.0001 15.1Z" fill="black"/>
          <path d="M12 19.3003C11.676 19.3003 11.376 19.1803 11.148 18.9523C11.04 18.8323 10.9561 18.7003 10.8841 18.5563C10.8241 18.4123 10.8 18.2563 10.8 18.1003C10.8 17.7883 10.932 17.4763 11.148 17.2483C11.592 16.8043 12.4081 16.8043 12.8521 17.2483C13.0681 17.4763 13.2 17.7883 13.2 18.1003C13.2 18.2563 13.164 18.4123 13.104 18.5563C13.044 18.7003 12.9601 18.8323 12.8521 18.9523C12.6241 19.1803 12.324 19.3003 12 19.3003Z" fill="black"/>
          <path d="M12.0004 25.9002C11.1964 25.9002 10.3804 25.6962 9.6604 25.2762L2.5324 21.1602C1.0924 20.3202 0.192383 18.7722 0.192383 17.1042V8.89624C0.192383 7.22824 1.0924 5.68023 2.5324 4.84023L9.6604 0.724238C11.1004 -0.115762 12.8884 -0.115762 14.3404 0.724238L21.4684 4.84023C22.9084 5.68023 23.8084 7.22824 23.8084 8.89624V17.1042C23.8084 18.7722 22.9084 20.3202 21.4684 21.1602L14.3404 25.2762C13.6204 25.6962 12.8044 25.9002 12.0004 25.9002ZM12.0004 1.90021C11.5084 1.90021 11.0044 2.03222 10.5604 2.28422L3.4324 6.40022C2.5444 6.91622 1.99238 7.86424 1.99238 8.89624V17.1042C1.99238 18.1242 2.5444 19.0842 3.4324 19.6002L10.5604 23.7162C11.4484 24.2322 12.5524 24.2322 13.4284 23.7162L20.5564 19.6002C21.4444 19.0842 21.9964 18.1362 21.9964 17.1042V8.89624C21.9964 7.87624 21.4444 6.91622 20.5564 6.40022L13.4284 2.28422C12.9964 2.03222 12.4924 1.90021 12.0004 1.90021Z" fill="black"/>
          </svg>
        </button>
    `;
  }

  set items(value) {
    this._data = value;
    this.shadowRoot.querySelector("#feedbackTitle").innerHTML =
      this._data.title;
    this.shadowRoot.querySelector("#userFeedBack").placeholder =
      this._data.placeHolder;
    if (this._data?.checkboxes) {
      this._data?.checkboxes.forEach((item) => {
        let checkContain = document.createElement("div");
        checkContain.className = "single-checkbox-contain";

        let checkBox = document.createElement("input");
        checkBox.classList.add("feed-checkbox");
        checkBox.setAttribute("type", "checkbox");
        checkBox.setAttribute("id", `check_${item.trim()}`);
        checkBox.value = item.trim();

        let checkBoxLabel = document.createElement("label");
        checkBoxLabel.innerHTML = item.trim();
        checkBoxLabel.setAttribute("for", `check_${item.trim()}`);

        checkContain.append(checkBox, checkBoxLabel);

        this.shadowRoot.querySelector("#checkboxes").appendChild(checkContain);
      });
    }
  }

  get items() {
    return this._data;
  }
  setDisable() {
    let npsState = false;
    this._feedbackNpsScores.forEach((item) => {
      if (item.dataset.selected == "true") {
        npsState = true;
      }
    });
    if (
      // this.shadowRoot.querySelector("#userFeedBack").value === "" ||
      !npsState
    ) {
      this.shadowRoot.querySelector("#submitFeedBtn").disabled = true;
    } else {
      this.shadowRoot.querySelector("#submitFeedBtn").disabled = false;
    }
  }

  connectedCallback() {
    this._overlayContainer = this.shadowRoot.querySelector(
      ".feed-overlay-container"
    );
    this._overlay = this.shadowRoot.querySelector(".feed-overlay");
    this._feedButton = this.shadowRoot.querySelector("#feedButton");
    this._feedIcon = this.shadowRoot.querySelector("#feedIcon");
    this._feedSubmitBtn = this.shadowRoot.querySelector("#submitFeedBtn");
    this._feedbackTitle = this.shadowRoot.querySelector("#feedbackTitle");
    this._feedbackCheckboxes = this.shadowRoot.querySelector("#checkboxes");
    this._userFeedBack = this.shadowRoot.querySelector("#userFeedBack");
    this._feedbackNpsScores = this.shadowRoot.querySelectorAll(".nps-score");
    this._feedCloseBtn = this.shadowRoot.querySelector("#feedCloseBtn");
    let npsScore = null;

    this._userFeedBack.addEventListener("input", (e) => {
      this.setDisable();
    });
    this._feedbackNpsScores.forEach((item) => {
      item.addEventListener("click", (event) => {
        this._feedbackNpsScores.forEach((item) => {
          item.dataset.selected = "false";
          item.classList.remove("selected");
        });
        if (event.target.dataset.selected == "false") {
          event.target.dataset.selected = "true";
          event.target.classList.add("selected");
          npsScore = event.target.innerHTML;
        }
        this.setDisable();
      });
    });

    if (this.hasAttribute("feed-type")) {
      this._feedButton.classList.add(this.getAttribute("feed-type"));
      this._feedIcon.classList.add(this.getAttribute("feed-type"));
    }

    this._feedButton.addEventListener("click", (e) => {
      this._overlayContainer.style.display = "flex";
      this._overlayContainer.style.opacity = "1";
      setTimeout(() => {
        this._overlay.classList.add("feed-visible");
      }, 200);
    });
    this._feedCloseBtn.addEventListener("click", (e) => {
      this._overlay.classList.remove("feed-visible");
      setTimeout(() => {
        this._overlayContainer.style.display = "none";
        this._overlayContainer.style.opacity = "0";
      }, 200);
      this._feedbackNpsScores.forEach((item) => {
        item.dataset.selected = "false";
        item.classList.remove("selected");
      });
      this._feedSubmitBtn.disabled = true;
      npsScore = null;
    });
    this._overlayContainer.addEventListener("click", (e) => {
      let isOutside = !e.target.closest(".feed-overlay");
      if (isOutside) {
        this._overlay.classList.remove("feed-visible");
        setTimeout(() => {
          this._overlayContainer.style.display = "none";
          this._overlayContainer.style.opacity = "0";
        }, 200);
        this._feedbackNpsScores.forEach((item) => {
          item.dataset.selected = "false";
          item.classList.remove("selected");
        });
        this._feedSubmitBtn.disabled = true;
        npsScore = null;
      }
    });
    this._feedSubmitBtn.addEventListener("click", (e) => {
      let userFeedBack = this._userFeedBack.value;

      let userFeedBackChecks = [];

      let result = { userFeedBack };

      if (this._data?.checkboxes) {
        var ele = this.shadowRoot.querySelectorAll(".feed-checkbox");
        for (let i = 0; i < ele.length; i++) {
          if (ele[i].checked) {
            userFeedBackChecks.push(ele[i].value);
          }
        }

        result = { userFeedBack, userFeedBackChecks };
      }
      if (
        this._data?.botText &&
        this._data?.userQuestion &&
        this._data?.feedbackType
      ) {
        result.botText = this._data?.botText;
        result.userQuestion = this._data?.userQuestion;
        result.feedbackType = this._data?.feedbackType;
        result.npsScore = npsScore;
      }

      var customEvent = new CustomEvent("feedBackSubmit", {
        detail: result,
      });
      if (this._data.feedbackType == "positive") {
        document
          .querySelector(`${this._data.feedId}_1`)
          .dispatchEvent(customEvent);
        document.querySelector(`${this._data.feedId}_2`).style.display = "none";
      } else {
        document
          .querySelector(`${this._data.feedId}_2`)
          .dispatchEvent(customEvent);
        //document.querySelector(`${this._data.feedId}_1`).style.display = "none";
      }
      this._feedButton.disabled = true;
      this._overlay.classList.remove("feed-visible");
      setTimeout(() => {
        this._overlayContainer.style.display = "none";
        this._overlayContainer.style.opacity = "0";
      }, 200);
    });
  }

  setButtonStyle(hue) {
    let feedSubmitBtn = this.shadowRoot.querySelector("#submitFeedBtn");

    feedSubmitBtn.style.boxShadow = `4px 4px 0px hsl(${hue}, 26%, 71%)`;
  }
}

customElements.define("ria-feedback", Feedback);
